// systeme solaire avec gravite
// version 2d

planete[] p = new planete[1];
float xsol = 300;
float ysol = 300;
float dt=1;

void setup(){
  size(600,600);
  for (int i=0;i<p.length;i++) p[i] = new planete();
}

void draw(){
  //background(128);
  // le soleil au centre de la scene
  ellipse(xsol,ysol,50,50);
  // les planetes
  for (int i=0;i<p.length;i++)p[i].dessin();
  for (int i=0;i<p.length;i++)p[i].evolution();
}

class planete {
  float x,y;
  float vx,vy;
  float ax,ay;
  float xp, yp;
  float dia;
  planete(){
    x=random(0,width);
    y=random(0,height);
    float d = sqrt((x-xsol)*(x-xsol)+(y-ysol)*(y-ysol));
    //vx=random(-10,10);
    //vy=random(-10,10);
    vx=-40*(y-ysol)/sqrt(d*d*d);
    vy=40*(x-xsol)/sqrt(d*d*d);
    dia=random(5,10);
    xp = x; yp = y;
  }

  void evolution(){
    xp = x; yp = y;
   float dist2 = (x-xsol)*(x-xsol)+(y-ysol)*(y-ysol);
   float attraction = 100/dist2;
   ax = attraction*(xsol-x);
   ay = attraction*(ysol-y);
   vx = vx + ax*dt;
   vy = vy + ay*dt;
   x = x + vx*dt;
   y = y + vy*dt;
  }
  
  void dessin(){
   line(xp,yp,x,y);
   //ellipse(x,y,dia,dia);
  }  
}
  